#!/bin/bash
# Git bash prompt v0.2 (2012-10-09)
# By Romain Vimont (®om) <rom@rom1v.com>
#
# Save this file to ~/gitbashprompt and replace 'PS1' initialization by:
# . gitbashprompt
#
# See <http://blog.rom1v.com/2012/04/prompt-bash-pour-git/>

__git_bash_prompt() {
    # Colors
    local nocol='\001\e[0m\002'
    local col='\001\e[34m\002' # blue

    SFI="$IFS"
    IFS=/
    local path="$1"
    local tokens=($path)
    IFS="$SFI"
    local i=0
    local count=${#tokens[@]}
    while [ $i -lt $count ]
    do
        token="${tokens[$i]}"
        etoken="$token"
        if [ $i -gt 0 -o "$path" = / ]
        then
            printf /
            curpath="$curpath/"
        else
            if [ "$token" = "~" ]
            then
                etoken="$HOME"
            fi
    fi
    if [ "$token" ]
    then
        curpath="$curpath$etoken"
        printf "$token"
        cd "$etoken"
    else
        cd /
    fi
        if [ -e .git ]
        then
            gitinfo="$(git branch 2>/dev/null | grep "^*" | cut -c3-)"
            if [ "$gitinfo" ]
            then
                printf $col@"$gitinfo"$nocol
            fi
        fi
    i=$(($i+1))
    done
}

PS1='\u@\h:$(__git_bash_prompt "\w")\$ '
